<?php 
add_action( 'widgets_init','business_a_service_widget'); 
/*
 * business service widget
 */
function business_a_service_widget() 
{ 
	return   register_widget( 'business_a_service_widget' );
}

class business_a_service_widget extends WP_Widget {

	function __construct() {
		parent::__construct('business_a_service_widget', 
		__('Business : Service Widget', 'business-a' ),
		array( 
			'description' => __( 'Business Service Widget', 'business-a' ),
		) );
	}

	public function widget( $args , $instance ) {
		
		$services_ids = array();
		$item_number = 3;
		for ( $i = 1; $i <= $item_number; $i++ ) {
			if ( ! empty( $instance["item_id_$i"] ) && absint( $instance["item_id_$i"] ) > 0 ) {
				$id = absint( $instance["item_id_$i"] );
				$services_ids[ $id ]['id']   = $id;
				$services_ids[ $id ]['icon'] = $instance["item_icon_$i"];
			}
		}
		
		if ( ! empty( $services_ids ) ) {
			$query_args = array(
				'posts_per_page' => count( $services_ids ),
				'post__in'       => wp_list_pluck( $services_ids, 'id' ),
				'orderby'        => 'post__in',
				'post_type'      => 'page',
				'no_found_rows'  => true,
				);
			$all_services = get_posts( $query_args );
			
			if ( ! empty( $all_services ) ) :
				global $post;
				foreach ( $all_services as $post ) :
					setup_postdata( $post );
						
						echo $args['before_widget'];
						?>
							<div class="rdn-service-area">
								
								<div class="rdn-service-icon-area">
									<a class="rdn-service-icon" <?php the_permalink(); ?>><i class="fa <?php echo esc_attr( $services_ids[ $post->ID ]['icon'] ); ?>"></i></a>
								</div>
								
								<?php echo $args['before_title']; ?>
									<a href="<?php the_permalink(); ?>">
										<?php the_title(); ?>
									</a>
								<?php echo $args['after_title']; ?>
								
								<p><?php the_excerpt(); ?></p>
								
								<a class="rdn-service-btn" href="<?php the_permalink(); ?>" ><?php _e('Read More','business-a' ); ?></a>
							</div>
						<?php
					
					echo $args['after_widget']; 
		
					wp_reset_postdata();
				endforeach;
			endif;
		}
			
	}

	public function form( $instance ) {
		// Defaults.
		$defaults = array();
		$item_number = 3;
		for ( $i = 1; $i <= $item_number; $i++ ) {
			$defaults["item_id_$i"]   = '';
			$defaults["item_icon_$i"] = 'fa-cog';
		}
		$instance = wp_parse_args( (array) $instance, $defaults );
		for ( $i = 1; $i <= $item_number; $i++ ) {
			?>
			<p>
				<label for="<?php echo $this->get_field_id( "item_id_$i" ); ?>"><strong><?php _e( 'Page:', 'business-a' ); ?>&nbsp;<?php echo $i; ?></strong></label>
				<?php
				wp_dropdown_pages( array(
					'id'               => $this->get_field_id( "item_id_$i" ),
					'class'            => 'widefat',
					'name'             => $this->get_field_name( "item_id_$i" ),
					'selected'         => $instance["item_id_$i"],
					'show_option_none' => esc_html__( '&mdash; Select &mdash;', 'business-a' ),
					)
				);
				?>
			</p>
			<p>
				<label for="<?php echo esc_attr( $this->get_field_id( "item_icon_$i" ) ); ?>"><?php _e( "Icon: { like: fa-desktop } ",'business-a' ); ?><a href="<?php echo esc_url('//fortawesome.github.io/Font-Awesome/icons/'); ?>" target="_blank" ><?php _e('Click Here!' , 'business-a' ); ?></a></label>
				<input  id="<?php echo esc_attr( $this->get_field_id( "item_icon_$i" ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( "item_icon_$i" ) ); ?>" type="text" value="<?php echo esc_attr( $instance["item_icon_$i"] ); ?>" />
			</p>
			<?php
		}
	}

	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance = $old_instance;
		$item_number = 3;

		for ( $i = 1; $i <= $item_number; $i++ ) {
			$instance["item_id_$i"]   = absint( $new_instance["item_id_$i"] );
			$instance["item_icon_$i"] = esc_attr( $new_instance["item_icon_$i"] );
		}

		return $instance;
	}

} // class